<template>
  <el-dialog
    width="30%"

    :visible="dialogFormvisible"
    append-to-body
    @close="$emit('update:dialogFormvisible', false)"
  >
    <h2> Add Honey Balance</h2>
    <el-form
      id="add-form"
      :model="data"
      :rules="rules"
      ref="data"
      label-width="120px"
      class="demo-content"
      v-loading="loading"
    >
      <el-form-item label="Balance" prop="balance" >
        <el-input-number :min="1" v-model="data.balance"></el-input-number>
      </el-form-item>

      <div style="text-align: right; margin-top: 30px;">
        <el-button
          type="primary"
          @click="submitForm('data')"
          :disabled="loading"
          icon="mdi mdi-plus"
        >Add</el-button>
      </div>
    </el-form>
  </el-dialog>
</template>

<script>
import $ from "jquery";
import { employer as employerAPI } from "~/services/apis/index";
export default {
  name: "AddHoney",
  props: ["dialogFormvisible"],

  data() {
    return {
      data: {
        balance: ""
      },
      rules: {
        balance: [
          {
            required: true,
            message: "Please input honey balance",
            trigger: "blur"
          },
        ]
      },
      loading: false
    };
  },
  methods: {
    submitForm(formName) {

      if (!this.$refs[formName]) return false;
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.loading = true;
          this.create(this.data.balance);
        } else {
          this.loading = false;
          return false;
        }
      });
    },
    resetForm(formName) {
      if (!this.$refs[formName]) return;
      this.$refs[formName].resetFields();
    },
    // onRemoveImg(e){
    //     e.preventDefault();
    //     e.stopPropagation();
    //     this.removeImg();
    // },
    // removeImg(){
    //     this.imageUrl = "";
    //     this.imageName = "";
    //     this.file = null;
    // },
    // submit(){
    //     this.loading = true;
    //     if(this.file){
    //         mediaAPI.upload(this.file)
    // 		.then((res) => {
    // 			this.create(res.data.data.path)

    // 		})
    // 		.catch((err)=>{
    // 			this.loading = false;
    // 			this.$notify.error({
    // 				title: 'Error',
    // 				message: 'Icon upload failed'
    // 			});
    // 			this.$emit('update:dialogFormvisible', false);
    // 		})
    // 	}else{
    // 		this.create()
    // 	}
    // },
    create(balance) {
      employerAPI
        .addHoneyBalance(balance, this.$route.name, this.$route.params.id)
        .then(res => {
          if (res.status === 200) {
            this.$parent.getDetail();
            this.loading = false;

            this.$notify({
              title: "Success",
              message: "Add honey balance successfully!",
              type: "success"
            });
            this.$emit("update:dialogFormvisible", false);
          }
        })
        .catch(err => {
          this.loading = false;
          this.$notify.error({
            title: "Error",
            message: "Cannot add honey"
          });
          console.log("err :", err);
          this.$emit("update:dialogFormvisible", false);
        });
    },
    resetDialog() {
      this.resetForm("data");
    }
  },
  mounted() {
    var that = this;
    $("body").on("submit", "#add-form", function(e) {
      event.preventDefault();
      that.submitForm("data");
    });
  },
  watch: {
    dialogFormvisible: function() {
      this.resetDialog();
    }
  }
};
</script>

<style lang="scss">
@import "../../assets/scss/_variables";
.item-full-width .el-form-item__content {
  margin-left: 0 !important;
}
.el-dialog__body {
  form {
    margin-top: 10px;
    .el-input-number {
      width: auto;
      /*max-width: 180px;*/
    }
  }
}
</style>
